/*
***** BEGIN LICENSE BLOCK *****
Version: MPL 1.1/GPL 2.0/LGPL 2.1

The contents of this file are subject to the Mozilla Public License Version 
1.1 (the "License"); you may not use this file except in compliance with 
the License. You may obtain a copy of the License at 
http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
for the specific language governing rights and limitations under the
License.

The Original Code is Any Confirmation Message before Send.

The Initial Developer of the Original Code is
SAKURAI Kenichi <http://something.cool.coocan.jp/kenichi/>.
Portions created by the Initial Developer are Copyright (C) 2009
the Initial Developer. All Rights Reserved.

Contributor(s):

Alternatively, the contents of this file may be used under the terms of
either the GNU General Public License Version 2 or later (the "GPL"), or
the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
in which case the provisions of the GPL or the LGPL are applicable instead
of those above. If you wish to allow use of your version of this file only
under the terms of either the GPL or the LGPL, and not to allow others to
use your version of this file under the terms of the MPL, indicate your
decision by deleting the provisions above and replace them with the notice
and other provisions required by the GPL or the LGPL. If you do not delete
the provisions above, a recipient may use your version of this file under
the terms of any one of the MPL, the GPL or the LGPL.

***** END LICENSE BLOCK *****
*/

var acmbs_db = {};

acmbs_db.connectDb = function(){
    var file = Components.
	classes["@mozilla.org/file/directory_service;1"].
	getService (Components.interfaces.nsIProperties).
	get ("ProfD", Components.interfaces.nsIFile);

    file.append ("acmbs");

    if (!file.exists()){
	file.create (Components.interfaces.nsIFile.DIRECTORY_TYPE, 0755);
    }

    file.append ("acmbs.sqlite");

    var storageService = Components.
	classes["@mozilla.org/storage/service;1"].
	getService (Components.interfaces.mozIStorageService);

    acmbs_db.connect = storageService.openDatabase (file);

    if (!acmbs_db.connect.tableExists ("acmbs_config")){
	acmbs_db.connect.executeSimpleSQL ("create table acmbs_config (id integer primary key, code interger, val text)");

	acmbs_db.connect.
	    executeSimpleSQL ("insert into acmbs_config (code, val) values (" +
			      1 +
			      ", '" +
			      acmbs_util.getString ("acmbsDefaultMessage") +
			      "')");
    }
};

acmbs_db.getConfirmationMessage = function(){
    var result = "";

    try{
	if (!acmbs_db.connect){
	    acmbs_db.connectDb();
	}

	if (acmbs_db.connect){
	    var statement = acmbs_db.connect.createStatement ("select val from acmbs_config where code = (?1)");

	    try{
		statement.bindUTF8StringParameter (0, "1");
		if (statement.executeStep()){
		    result = statement.getString (0);
		}
	    } finally{
		statement.reset();
	    }
	}

	if (result == ""){
	    result = acmbs_util.getString ("acmbsDefaultMessage");
	}
    } finally{
	return result;
    }
};

acmbs_db.setConfirmationMessage = function (arg){
    var result = 0;

    try{
	if (!acmbs_db.connect){
	    acmbs_db.connectDb();
	}

	if (acmbs_db.connect){
	    var statement = acmbs_db.connect.createStatement ("update acmbs_config set val = (?1) where code = (?2)");

	    try{
		statement.bindUTF8StringParameter (0, arg);
		statement.bindUTF8StringParameter (1, "1");
		statement.execute();
	    } catch (e){
		result = -1;
	    } finally{
		statement.reset();
	    }
	}
    } catch (e){
	result = -1;
    }

    return result;
};
